#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include "timing.h"

int main( void )
{
	unsigned long ticksB4, ticksAFT, ticks;
	double freq = 2.5e9;

    int i, j, n = 4;


	get_ticks(ticksB4);

    // Try also uncommenting the line below
    omp_set_nested(1);
    printf("Nested? %s\n", omp_get_nested() ? "TRUE" : "FALSE" );

    #pragma omp parallel for num_threads(4)
    for ( i = 0; i < n; i++ ) {
        printf( "Num threads: %d\n", omp_get_num_threads());
		sleep(1);
        #pragma omp parallel for num_threads(4)
        for ( j = 0; j < n; j++ ) {
            printf( "\tNum threads: %d\n", omp_get_num_threads());
			sleep(1);
        }
    }


	get_ticks(ticksAFT);
	ticks = ticksAFT - ticksB4;
	printf("runtime (s): %g\n\n", ticks/freq);
}
